/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _ATTENDEE_H_
#define _ATTENDEE_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class AttendeeRole;
    class UnionOfAlarmEventFreebusyJournalTodo;
    class Contact;
    class ParticipationStatus;
    class CalendarUserType;

}

#include "attendeeororganizer.h"

namespace NepomukFast {

    /**
     * An attendee of an event. This class has been introduced to serve 
     * as the range for ncal:attendee property. See documentation 
     * of ncal:attendee for details. 
     */
    class Attendee : public AttendeeOrOrganizer
    {
    public:
        /**
         * Create a new empty and invalid Attendee instance
         */
        Attendee( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'delegatedFrom'. To specify the calendar users 
         * that have delegated their participation to the calendar user 
         * specified by the property. Inspired by RFC 2445 sec. 4.2.4. 
         * Originally the value type for this property was CAL-ADDRESS. 
         * This has been expressed as nco:Contact to promote integration 
         * between NCAL and NCO. 
         */
        void setDelegatedFroms( const QList<Contact>& value );

        /**
         * Add a value to property 'delegatedFrom'. To specify the calendar 
         * users that have delegated their participation to the calendar 
         * user specified by the property. Inspired by RFC 2445 sec. 4.2.4. 
         * Originally the value type for this property was CAL-ADDRESS. 
         * This has been expressed as nco:Contact to promote integration 
         * between NCAL and NCO. 
         */
        void addDelegatedFrom( const Contact& value );

        /**
         * \return The URI of the property 'delegatedFrom'. 
         */
        static QUrl delegatedFromUri();

        /**
         * Set property 'cutype'. To specify the type of calendar user 
         * specified by the property. Inspired by RFC 2445 sec. 4.2.3. 
         * This parameter has a limited vocabulary. The terms that may 
         * serve as values for this property have been expressed as instances 
         * of CalendarUserType class. The user may use instances provided 
         * with this ontology or create his own. 
         */
        void setCutypes( const QList<CalendarUserType>& value );

        /**
         * Add a value to property 'cutype'. To specify the type of calendar 
         * user specified by the property. Inspired by RFC 2445 sec. 4.2.3. 
         * This parameter has a limited vocabulary. The terms that may 
         * serve as values for this property have been expressed as instances 
         * of CalendarUserType class. The user may use instances provided 
         * with this ontology or create his own. 
         */
        void addCutype( const CalendarUserType& value );

        /**
         * \return The URI of the property 'cutype'. 
         */
        static QUrl cutypeUri();

        /**
         * Set property 'member'. To specify the group or list membership 
         * of the calendar user specified by the property. Inspired by 
         * RFC 2445 sec. 4.2.11. Originally this parameter had a value 
         * type of CAL-ADDRESS. This has been expressed as nco:Contact 
         * to promote integration between NCAL and NCO 
         */
        void setMembers( const QList<Contact>& value );

        /**
         * Add a value to property 'member'. To specify the group or list 
         * membership of the calendar user specified by the property. 
         * Inspired by RFC 2445 sec. 4.2.11. Originally this parameter 
         * had a value type of CAL-ADDRESS. This has been expressed as nco:Contact 
         * to promote integration between NCAL and NCO 
         */
        void addMember( const Contact& value );

        /**
         * \return The URI of the property 'member'. 
         */
        static QUrl memberUri();

        /**
         * Set property 'rsvp'. To specify whether there is an expectation 
         * of a favor of a reply from the calendar user specified by the property 
         * value. Inspired by RFC 2445 sec. 4.2.17 
         */
        void setRsvps( const QList<bool>& value );

        /**
         * Add a value to property 'rsvp'. To specify whether there is an 
         * expectation of a favor of a reply from the calendar user specified 
         * by the property value. Inspired by RFC 2445 sec. 4.2.17 
         */
        void addRsvp( const bool& value );

        /**
         * \return The URI of the property 'rsvp'. 
         */
        static QUrl rsvpUri();

        /**
         * Set property 'partstat'. To specify the participation status 
         * for the calendar user specified by the property. Inspired by 
         * RFC 2445 sec. 4.2.12. Originally this parameter had three sets 
         * of allowed values. Which set applied to a particular case - depended 
         * on the type of calendar entity this parameter occured in. (event, 
         * todo, journal entry). This would be awkward to model in RDF so 
         * a single ParticipationStatus class has been introduced. Terms 
         * of the values vocabulary are expressed as instances of this 
         * class. Users are advised to pay attention which instances they 
         * use. 
         */
        void setPartstats( const QList<ParticipationStatus>& value );

        /**
         * Add a value to property 'partstat'. To specify the participation 
         * status for the calendar user specified by the property. Inspired 
         * by RFC 2445 sec. 4.2.12. Originally this parameter had three 
         * sets of allowed values. Which set applied to a particular case 
         * - depended on the type of calendar entity this parameter occured 
         * in. (event, todo, journal entry). This would be awkward to model 
         * in RDF so a single ParticipationStatus class has been introduced. 
         * Terms of the values vocabulary are expressed as instances of 
         * this class. Users are advised to pay attention which instances 
         * they use. 
         */
        void addPartstat( const ParticipationStatus& value );

        /**
         * \return The URI of the property 'partstat'. 
         */
        static QUrl partstatUri();

        /**
         * Set property 'delegatedTo'. To specify the calendar users 
         * to whom the calendar user specified by the property has delegated 
         * participation. Inspired by RFC 2445 sec. 4.2.5. Originally 
         * the value type for this parameter was CAL-ADDRESS. This has 
         * been expressed as nco:Contact to promote integration between 
         * NCAL and NCO. 
         */
        void setDelegatedTos( const QList<Contact>& value );

        /**
         * Add a value to property 'delegatedTo'. To specify the calendar 
         * users to whom the calendar user specified by the property has 
         * delegated participation. Inspired by RFC 2445 sec. 4.2.5. 
         * Originally the value type for this parameter was CAL-ADDRESS. 
         * This has been expressed as nco:Contact to promote integration 
         * between NCAL and NCO. 
         */
        void addDelegatedTo( const Contact& value );

        /**
         * \return The URI of the property 'delegatedTo'. 
         */
        static QUrl delegatedToUri();

        /**
         * Set property 'role'. To specify the participation role for 
         * the calendar user specified by the property. Inspired by the 
         * RFC 2445 sec. 4.2.16. Originally this property had a limited 
         * vocabulary for values. The terms of that vocabulary have been 
         * expressed as instances of the AttendeeRole class. 
         */
        void setRoles( const QList<AttendeeRole>& value );

        /**
         * Add a value to property 'role'. To specify the participation 
         * role for the calendar user specified by the property. Inspired 
         * by the RFC 2445 sec. 4.2.16. Originally this property had a limited 
         * vocabulary for values. The terms of that vocabulary have been 
         * expressed as instances of the AttendeeRole class. 
         */
        void addRole( const AttendeeRole& value );

        /**
         * \return The URI of the property 'role'. 
         */
        static QUrl roleUri();



    protected:
        Attendee( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
