/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "personcontact.h"

#include "affiliation.h"
#include "gender.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::PersonContact::PersonContact( const QUrl &uri, const QUrl &graphUri )
  : Contact( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PersonContact", QUrl::StrictMode) )
{
}

NepomukFast::PersonContact::PersonContact( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : Contact( uri, graphUri, type )
{
}

void NepomukFast::PersonContact::setNameHonorificSuffixs( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PersonContact::addNameHonorificSuffix( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PersonContact::nameHonorificSuffixUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix");
}

void NepomukFast::PersonContact::setNameFamilys( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PersonContact::addNameFamily( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PersonContact::nameFamilyUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily");
}

void NepomukFast::PersonContact::setNameHonorificPrefixs( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PersonContact::addNameHonorificPrefix( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PersonContact::nameHonorificPrefixUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix");
}

void NepomukFast::PersonContact::setNameAdditionals( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PersonContact::addNameAdditional( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PersonContact::nameAdditionalUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional");
}

void NepomukFast::PersonContact::setNameGivens( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PersonContact::addNameGiven( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PersonContact::nameGivenUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven");
}

void NepomukFast::PersonContact::setHobbys( const QStringList& value )
{
    for( QStringList::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::PersonContact::addHobby( const QString& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::PersonContact::hobbyUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby");
}

void NepomukFast::PersonContact::setAffiliations( const QList<NepomukFast::Affiliation>& value )
{
    for( QList<Affiliation>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation"), (*it).uri() );
    }
}

void NepomukFast::PersonContact::addAffiliation( const NepomukFast::Affiliation& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation"), value.uri() );
}

QUrl NepomukFast::PersonContact::affiliationUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation");
}

void NepomukFast::PersonContact::setGender( const NepomukFast::Gender& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#gender"), value.uri() );
}

QUrl NepomukFast::PersonContact::genderUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#gender");
}


