/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _PERSONCONTACT_H_
#define _PERSONCONTACT_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Affiliation;
    class Gender;

}

#include "contact.h"

namespace NepomukFast {

    /**
     * A Contact that denotes a Person. A person can have multiple Affiliations. 
     */
    class PersonContact : public Contact
    {
    public:
        /**
         * Create a new empty and invalid PersonContact instance
         */
        PersonContact( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'nameHonorificSuffix'. A suffix for the name 
         * of the Object represented by the given object. See documentation 
         * for the 'nameFamily' for details. 
         */
        void setNameHonorificSuffixs( const QStringList& value );

        /**
         * Add a value to property 'nameHonorificSuffix'. A suffix for 
         * the name of the Object represented by the given object. See documentation 
         * for the 'nameFamily' for details. 
         */
        void addNameHonorificSuffix( const QString& value );

        /**
         * \return The URI of the property 'nameHonorificSuffix'. 
         */
        static QUrl nameHonorificSuffixUri();

        /**
         * Set property 'nameFamily'. The family name of an Object represented 
         * by this Contact. These applies to people that have more than 
         * one given name. The 'first' one is considered 'the' given name 
         * (see nameGiven) property. All additional ones are considered 
         * 'additional' names. The name inherited from parents is the 
         * 'family name'. e.g. For Dr. John Phil Paul Stevenson Jr. M.D. 
         * A.C.P. we have contact with: honorificPrefix: 'Dr.', nameGiven: 
         * 'John', nameAdditional: 'Phil', nameAdditional: 'Paul', 
         * nameFamily: 'Stevenson', honorificSuffix: 'Jr.', honorificSuffix: 
         * 'M.D.', honorificSuffix: 'A.C.P.'. These properties form 
         * an equivalent of the compound 'N' property as defined in RFC 
         * 2426 Sec. 3.1.2 
         */
        void setNameFamilys( const QStringList& value );

        /**
         * Add a value to property 'nameFamily'. The family name of an Object 
         * represented by this Contact. These applies to people that have 
         * more than one given name. The 'first' one is considered 'the' 
         * given name (see nameGiven) property. All additional ones are 
         * considered 'additional' names. The name inherited from parents 
         * is the 'family name'. e.g. For Dr. John Phil Paul Stevenson Jr. 
         * M.D. A.C.P. we have contact with: honorificPrefix: 'Dr.', 
         * nameGiven: 'John', nameAdditional: 'Phil', nameAdditional: 
         * 'Paul', nameFamily: 'Stevenson', honorificSuffix: 'Jr.', 
         * honorificSuffix: 'M.D.', honorificSuffix: 'A.C.P.'. These 
         * properties form an equivalent of the compound 'N' property 
         * as defined in RFC 2426 Sec. 3.1.2 
         */
        void addNameFamily( const QString& value );

        /**
         * \return The URI of the property 'nameFamily'. 
         */
        static QUrl nameFamilyUri();

        /**
         * Set property 'nameHonorificPrefix'. A prefix for the name 
         * of the object represented by this Contact. See documentation 
         * for the 'nameFamily' property for details. 
         */
        void setNameHonorificPrefixs( const QStringList& value );

        /**
         * Add a value to property 'nameHonorificPrefix'. A prefix for 
         * the name of the object represented by this Contact. See documentation 
         * for the 'nameFamily' property for details. 
         */
        void addNameHonorificPrefix( const QString& value );

        /**
         * \return The URI of the property 'nameHonorificPrefix'. 
         */
        static QUrl nameHonorificPrefixUri();

        /**
         * Set property 'nameAdditional'. Additional given name of an 
         * object represented by this contact. See documentation for 
         * 'nameFamily' property for details. 
         */
        void setNameAdditionals( const QStringList& value );

        /**
         * Add a value to property 'nameAdditional'. Additional given 
         * name of an object represented by this contact. See documentation 
         * for 'nameFamily' property for details. 
         */
        void addNameAdditional( const QString& value );

        /**
         * \return The URI of the property 'nameAdditional'. 
         */
        static QUrl nameAdditionalUri();

        /**
         * Set property 'nameGiven'. The given name for the object represented 
         * by this Contact. See documentation for 'nameFamily' property 
         * for details. 
         */
        void setNameGivens( const QStringList& value );

        /**
         * Add a value to property 'nameGiven'. The given name for the object 
         * represented by this Contact. See documentation for 'nameFamily' 
         * property for details. 
         */
        void addNameGiven( const QString& value );

        /**
         * \return The URI of the property 'nameGiven'. 
         */
        static QUrl nameGivenUri();

        /**
         * Set property 'hobby'. A hobby associated with a PersonContact. 
         * This property can be used to express hobbies and interests. 
         */
        void setHobbys( const QStringList& value );

        /**
         * Add a value to property 'hobby'. A hobby associated with a PersonContact. 
         * This property can be used to express hobbies and interests. 
         */
        void addHobby( const QString& value );

        /**
         * \return The URI of the property 'hobby'. 
         */
        static QUrl hobbyUri();

        /**
         * Set property 'Affiliation'. Links a PersonContact with an 
         * Affiliation. 
         */
        void setAffiliations( const QList<Affiliation>& value );

        /**
         * Add a value to property 'Affiliation'. Links a PersonContact 
         * with an Affiliation. 
         */
        void addAffiliation( const Affiliation& value );

        /**
         * \return The URI of the property 'Affiliation'. 
         */
        static QUrl affiliationUri();

        /**
         * Set property 'gender'. Gender of the given contact. 
         */
        void setGender( const Gender& value );

        /**
         * \return The URI of the property 'gender'. 
         */
        static QUrl genderUri();



    protected:
        PersonContact( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
